#include <bits/stdc++.h>

using namespace std;

enum Direction {In, Out};

#define ll long long
int main() {
    cin.sync_with_stdio(false);
    cin.tie(nullptr);
    int N;
    int XX0, YY0;
    long long RR0;
    cin >> N >> RR0 >> XX0 >> YY0;

    if (XX0 == 0 && YY0 == 0) {
        int s = 0;
        for (int i = 0; i < N; i++) {
            long long x,y;
            cin >> x >> y;
            if (x*x + y*y <= RR0*RR0) {
                s++;
            }
        }
        cout << s << endl;
        return 0;
    }
    double R;
    R = RR0;
    R += 0.0005; // 5*10^-4
    ll RR = R*R;

    typedef pair<double, Direction> val;
    vector<val> T;
    int s = 0;
    for (int i = 0; i < N; i++) {
        int x,y;
        cin >> x >> y;
        ll a,b;
        double c;
        a = XX0*XX0+YY0*YY0; // a > 0
        b = -2*XX0*x - 2*YY0*y;
        c = x*x+y*y - RR;
        double disc = (double)b*b-4.0*a*c; // hazard?
        if (disc < 0)
            continue;
        double nagy = (-b + sqrt(disc)) / (2*a); // hazard!
        double kicsi = (-b - sqrt(disc)) / (2*a); // hazard!
        cout << kicsi << " " << nagy << endl;
        if (kicsi < 0)
            s++;
        else if (kicsi <= 1)
            T.push_back({kicsi, In});
        if (nagy < 0)
            s--;
        else if (nagy <= 1)
            T.push_back({nagy, Out});
    }
    cout << s << endl;
    cout << T.size() << endl;
    sort(T.begin(), T.end(), [](const val& a, const val& b) {
        if (a.first == b.first) {
            if (a.second == Out && b.second == In)
                return false;
            return true;
        }
        return a.first < b.first;
    });
    int m = s;
    for (const val& t: T) {
        if (t.second == In)
            s++;
        else if (t.second == Out)
            s--;
        if (m < s) m = s;
    }
    cout << m << endl;
    return 0;
}